目录
题目类型
此类题目不用什么复杂的算法,题目基本已经告诉你怎么做,只需要将题目所述转化为代码即可, 所以该类题目重点考察代码能力~
leetcode/牛客题目
一、替换所有的问号
字符串只包含小写字母和'?', 替换所有的'?'成小写字母,使得字符串中不包含连续重复字符
2.算法分析
遍历一遍原始字符串,遇到'?'之后,依次尝试'a'~'z'所有字符使得和前一个位置与后一个位置字符都不重复即可!
细节问题: 第一个字符是'?'与最后一个字符是'?',只需要检查一边即可
3.算法代码
class Solution {
public:
string modifyString(string s)
{
int n = s.size();
for(int i = 0; i < n; i++)
{
if(s[i] == '?')
{
for(char ch = 'a'; ch <= 'z'; ch++)
{
if( (i == 0 || ch != s[i-1]) && (i == n-1 || ch != s[i+1]))
{
s[i] = ch;
break;
}
}
}
}
return s;
}
};
二、提莫攻击
495. 提莫攻击 - 力扣(LeetCode)https://leetcode.cn/problems/teemo-attacking/
1.题目解析
给定一个数组,数组每个元素表示发起攻击(被攻击后会中毒)的时间,给定一个整数,表示中毒的时长,如果中毒还没有结束,就发起下次攻击,那么中毒时间被重置!题目要求返回中毒的总时间
2.算法分析
只需要分析相邻两次攻击的时间差x即可,如果 x >= d(中毒时间), 说明下一次攻击之前,中毒已经恢复,所以 ret += d(中毒时间); 如果 x < d, 说明中毒还没有结束,就已经进行了下一次攻击,说明这两次相邻攻击之间全程中毒,ret += x;
细节问题: 最后算完后还要加上中毒时间d
3.算法代码
class Solution {
public:
int findPoisonedDuration(vector<int>& t, int d)
{
int n = t.size();
int ret = 0;
for(int i = 1; i < n; i++)
{
int x = t[i] - t[i-1];
if(x >= d) ret += d;
else ret += x;
}
return ret + d;
}
};
三、Z字型变换
6. Z 字形变换 - 力扣(LeetCode)https://leetcode.cn/problems/zigzag-conversion/
1.题目解析
给定一个字符串,按照"Z字型"排列,然后输出逐行读取的结果
2.算法分析
模拟+找规律
3.算法代码
class Solution {
public:
string convert(string s, int numRows)
{
//处理边界情况
if(numRows == 1) return s;
int n = s.size(); //最多有n列
string ret;
int d = 2 * numRows - 2;
//1.处理第一行
for(int i = 0; i < n; i+=d)
ret += s[i];
//2.处理中间行
for(int k = 1; k < numRows-1; k++) //枚举每一行
{
for(int i = k, j = d - k; i < n || j < n; i += d, j += d) //有可能i越界了,但是j还没有越界,因此判断条件要用 ||
{
if(i < n) ret += s[i];
if(j < n) ret += s[j];
}
}
//3.处理最后一行
for(int i = numRows-1; i < n; i+=d)
ret += s[i];
return ret;
}
};
四、外观数列
38. 外观数列 - 力扣(LeetCode)https://leetcode.cn/problems/count-and-say/1.题目解析
给一个整数n, 输出外观数列的第n项, 具体参看题目
2.算法分析
3.算法代码
class Solution {
public:
string countAndSay(int n)
{
string ret = "1";
while(--n) //解释n-1次
{
string tmp;
int left = 0, right = 0; //双指针
while(right < ret.size())
{
while(ret[left] == ret[right]) right++;
tmp += to_string(right - left) + ret[left];
left = right;
}
ret = tmp;
}
return ret;
}
};
五、数青蛙
1419. 数青蛙 - 力扣(LeetCode)https://leetcode.cn/problems/minimum-number-of-frogs-croaking/1.题目解析
模拟青蛙叫声,求需要的青蛙的最小数量
2.算法原理
有正确结果:
没有正确结果:
总结:
1.遇到r/o/a/k字符,在哈希表中找一下前驱字符,如果存在,前驱个数--, 当前字符++, 不存在,则返回-1
2.遇到c字符,找最后一个字符(本题是k字符)在哈希表是否存在,存在则最后一个字符个数--,当前字符++, 不存在则当前字符++
注意最后还要检查记录字符出现个数的哈希表情况,如果前n-1个字符中有个数不为0的字符,也要返回-1
3.算法代码
class Solution {
public:
int minNumberOfFrogs(string croakOfFrogs)
{
string t = "croak";
int n = t.size();
vector<int> hash(n); //数组模拟哈希表, 记录t中字符出现的个数
unordered_map<char, int> index; //[x, x这个字符对应的下标]
for(int i = 0; i < n; i++)
index[t[i]] = i;
for(auto ch : croakOfFrogs)
{
if(ch == 'c')
{
if(hash[n-1] != 0) hash[n-1]--;
hash[0]++;
}
else
{
int i = index[ch]; //求出当前字符的下标
if(hash[i-1] == 0) return -1;
hash[i-1]--, hash[i]++;
}
}
for(int i = 0; i < n -1; i++)
if(hash[i] != 0)
return -1;
return hash[n-1];
}
};
六、数字统计
输入L与R, 求[L, R]区间内2出现的次数
2.算法分析
模拟即可
3.算法代码
#include <iostream>
using namespace std;
int main()
{
int L, R;
cin >> L >> R;
int cnt = 0;
for(int x = L; x <= R; x++)
{
int tmp = x;
while(tmp)
{
if(tmp % 10 == 2)
cnt++;
tmp /= 10;
}
}
cout << cnt << endl;
}
七、牛牛的快递
快递<=1kg, 20元,超出部分每kg 1元,不足1kg按1kg计算,如果要加急单独支付5元,问最终需要付费多少
2.算法分析
模拟即可
补充: ceil函数表示向上取整,比如ceil(3.4)结果就是4
当然不知道这个函数也无妨,可以通过判断是否是小数,从而得到最终结果
3.算法代码
ceil函数:
#include <iostream>
using namespace std;
#include <math.h>
int main()
{
float a;
char b;
cin >> a >> b;
int ret = 0;
if(a <= 1)
ret += 20;
else
{
ret += 20;
a -= 1;
ret += ceil(a);
}
if(b == 'y')
ret += 5;
cout << ret << endl;
}
不用ceil函数:
#include <iostream>
using namespace std;
#include <math.h>
int main()
{
float a;
char b;
cin >> a >> b;
int ret = 0;
if(a <= 1)
ret += 20;
else
{
ret += 20;
double c = a - 1;
if(c - (int)c > 0) ret += (int)c + 1;
else ret += (int)c;
}
if(b == 'y')
ret += 5;
cout << ret << endl;
}
八、简写单词
输入一行字符串,将字符串中的每个单词的首字母提取出来并变成大写,打印结果
2.算法分析
模拟即可:
首字母是小写,转化成大写输出即可,如果是大写,直接输出即可
3.算法代码
#include <iostream>
using namespace std;
int main()
{
string s;
while(cin >> s) //自动跳过空格
{
if(s[0] <= 'z' && s[0] >= 'a') cout << (char)(s[0] - 32);
else cout << s[0];
}
}
九、Fibonacci数列
给定一个数n,判断该数变为斐波那契数列至少需要几步(每次可以+1/-1)
2.算法分析
定义a, b, c变量,模拟求斐波那契数列的过程,如果n > c, a, b, c变量向后滚动,直到n <= c, 此时min(c-n, n-b)就是最终结果
3.算法代码
#include <iostream>
using namespace std;
int main()
{
int n;
cin >> n;
int a = 0, b = 1, c = 1;
while(c < n)
{
a = b;
b = c;
c = a + b;
}
cout << min(n-b, c-n) << endl;
return 0;
}
十、游游的you
游游的you__牛客网 (nowcoder.com)https://www.nowcoder.com/questionTerminal/cd117803b3364b218a8b3dcc498dee251.题目解析
现在有a个'y', b个'o', c个'u', 拼成'you'可以得2分,两个相邻的字母是'oo'可以得1分,现在问最多可以得多少分?
2.算法分析
用一点小贪心策略,'you'可以得2分, 'oo'可以得1分, 因此我们优先拼凑'you'
3.算法代码
#include <iostream>
using namespace std;
int main()
{
int q;
cin >> q;
while(q--)
{
int a, b, c;
cin >> a >> b >> c;
int x = min(a, min(b, c)); //you的个数
cout << (x * 2 + max(b-x-1, 0)) << endl; //b-x个'o'可以得b-x-1分
}
}
十一、字符串中找出连续最长的数字串
求字符串中连续最长的数字串
2.算法分析
双指针模拟即可, 用start变量和len变量记录字符串起始位置和数字串最长长度
3.算法代码
#include <iostream>
using namespace std;
int main()
{
string s;
cin >> s;
int begin = 0, len = 0;
for(int i = 0; i < s.size(); i++)
{
if(s[i] >= '0' && s[i] <= '9')
{
int j = i;
while(j < s.size() && s[j] >= '0' && s[j] <= '9')
j++;
if(j - i > len)
{
begin = i;
len = j - i;
}
i = j;
}
}
cout << s.substr(begin, len) << endl;
}
十二、拼三角
拼三角 (nowcoder.com)https://ac.nowcoder.com/acm/problem/2190461.题目解析
给定6根棍子,问是否能选出3根组成三角形,剩下三根也组成三角形,返回true/false
2.算法分析
暴力枚举即可,而也不需要枚举所有情况(C63), 因此abc&&def与def&&abc是一种情况
不过我们可以先排序,此时会方便很多:
1.判断是否是三角形只要前两个数 > 第三个数 即可
2.C63种情况只需要判断4种即可
[0, 1, 2, 3, 4, 5]
0 1 2 ~ 3 4 5 0 1 3 ~ 2 4 5 0 1 4 ~ 2 3 5 0 1 5 ~ 2 3 4
0 2 3 ~ 1 4 5 0 2 4 ~ 1 3 5 0 2 5 ~ 1 3 4
0 3 4 ~ 1 2 5 0 3 5 ~ 1 2 4
0 4 5 ~ 1 2 3
一共四列,只需要判断第一列即可,因为如果第一列成立,说明可以组成三角形,如果不成立,说明前两个数之和 < 第三个数,那么后面的组合前两个数 一定 < 第三个数,因此一定不能拼成三角形
3.算法代码
#include <iostream>
using namespace std;
#include <algorithm>
int t;
int arr[6];
int main()
{
cin >> t;
while(t--)
{
for(int i = 0; i < 6; i++) cin >> arr[i];
sort(arr, arr + 6);
if(arr[0] + arr[1] > arr[2] && arr[3] + arr[4] > arr[5]
|| arr[0] + arr[2] > arr[3] && arr[1] + arr[4] > arr[5]
|| arr[0] + arr[3] > arr[4] && arr[1] + arr[2] > arr[5]
|| arr[0] + arr[4] > arr[5] && arr[1] + arr[2] > arr[3])
{
cout << "Yes" << endl;
}
else
{
cout << "No" << endl;
}
}
return 0;
}
十三、求最小公倍数
求两数的最小公倍数
2.算法分析
a和b的最小公倍数 = a*b / a和b的最大公约数
3.算法代码
循环:
#include <iostream>
using namespace std;
int main()
{
int a, b;
cin >> a >> b;
int x = a, y = b;
while(a % b)
{
int t = a % b;
a = b;
b = t;
}
cout << (x * y / b) << endl;
}
递归:
#include <iostream>
using namespace std;
int gcd(int a, int b)
{
if(b == 0)
return a;
return gcd(b, a % b);
}
int main()
{
int a, b;
cin >> a >> b;
cout << (a * b / gcd(a, b)) << endl;
}
十四、数组中的最长连续子序列
返回数组中最长的连续子序列的长度(值是连续的,位置可以不连续)
2.算法分析
排序+双指针模拟
定义i, j下标,但数组中可能有重复元素,因此我们可以在找一段连续子序列时定义count变量,用来统计有效的连续子序列长度
3.算法代码
class Solution {
public:
int MLS(vector<int>& arr)
{
sort(arr.begin(), arr.end());
int n = arr.size(), ret= 0;
for(int i = 0; i < n;)
{
int j = i + 1, count = 1;
while(j < n)
{
if(arr[j] - arr[j-1] == 1)
{
count++;
j++;
}
else if(arr[j] - arr[j-1] == 0)
{
j++;
}
else
{
break;
}
}
ret = max(ret, count);
i = j; //将i更新到j的位置
}
return ret;
}
};
十五、添加逗号
输入整数n,每三位添加一个逗号
2.算法分析
法一: 依次取到n的每一位,加入到字符串ret的后面,计数器count++, 当计数器count变成3,ret后添加逗号,count置成0;循环结束后,判断字符串末尾是否是逗号,是逗号就删除逗号,最后逆序字符串
法二: 直接读入字符串(假如长度是n),观察下标规律,发现需要在满足 ((n-i-1) % 3 == 0) 的位置添加逗号,当然字符串最后一个位置也是满足上式,因此还要添加一个 i != n-1的判断条件
3.算法代码
法一:
#include <iostream>
using namespace std;
#include <algorithm>
int main()
{
int n;
cin >> n;
string ret;
int count = 0;
while(n)
{
int t = n % 10;
n /= 10;
ret += t + '0';
count++;
if(count == 3)
{
count = 0;
ret += ',';
}
}
if(ret.back() == ',') ret.pop_back();
reverse(ret.begin(), ret.end());
cout << ret << endl;
}
法二:
#include <iostream>
using namespace std;
#include <algorithm>
int main()
{
string s;
cin >> s;
int n = s.size();
string ret;
for(int i = 0; i < n; i++)
{
ret += s[i];
if((n - 1 - i) % 3 == 0 && i != n-1)
ret += ',';
}
cout << ret << endl;
}
十六、dd爱旋转
dd爱旋转 (nowcoder.com)https://ac.nowcoder.com/acm/problem/2217861.题目解析
给定矩阵,可以进行两种操作
1.旋转180°
2.关于行镜像
现有q次询问,求每次询问的结果矩阵
2.算法分析
1.旋转180°,可以通过先行对称,再列对称进行计算
2.对一个矩阵进行 行对称 和 列对称 的顺序无所谓
3.偶数次行对称 或 偶数次列对称 是可以抵消的
3.算法代码
#include <iostream>
using namespace std;
int arr[1001][1001];
int n;
int main()
{
cin >> n;
for(int i = 0; i < n; i++)
for(int j = 0;j < n; j++)
cin >> arr[i][j];
int q;
cin >> q;
int row = 0, col = 0;
while(q--)
{
int x;
cin >> x;
if(x == 1) row++, col++;
else row++;
}
row %= 2; col %= 2;
if(row)
{
for(int i = 0; i < n / 2; i++)
{
for(int j = 0; j < n; j++)
{
swap(arr[i][j], arr[n-1-i][j]);
}
}
}
if(col)
{
for(int j= 0; j < n / 2; j++)
{
for(int i = 0; i < n; i++)
{
swap(arr[i][j], arr[i][n-1-j]);
}
}
}
for(int i = 0; i < n; i++)
{
for(int j = 0;j < n; j++)
{
cout << arr[i][j] << " ";
}
cout << endl;
}
}